/**
Portable Memory-Mapped file interface
Orion Sky Lawlor, olawlor@acm.org, 2003/12/17
*/
#ifndef __OSL_MMAP_H
#define __OSL_MMAP_H

#include "osl/io.h"

namespace osl { namespace io {

typedef enum {
  MmapRead=1, MmapWrite=2, MmapReadWrite=3
} MmapAccess;

class MmapFile {
	File f;
	unsigned long len;
	MmapAccess access;
	void *data;
public:
	MmapFile(const File &f_,unsigned long len_,MmapAccess access_);
	~MmapFile();
	void *getData(void) const {return data;}
};

}; };

#endif
